'use strict';

var tslib_es6 = require('../__helpers/tslib/tslib.es6.js');
var encryption = require('@mongez/encryption');
var LocalForageDatabaseEngine = require('./LocalForageDatabaseEngine.js');

var EncryptedLocalForageDatabaseEngine = /** @class */ (function (_super) {
    tslib_es6.__extends(EncryptedLocalForageDatabaseEngine, _super);
    function EncryptedLocalForageDatabaseEngine() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    /**
     * Set data into storage engine
     * @param {string} key
     * @param {value} value
     */
    EncryptedLocalForageDatabaseEngine.prototype.set = function (key, value) {
        return this.storage.setItem(this.getKey(key), encryption.encrypt(value));
    };
    /**
     * Get vale from storage engine
     *
     * @param   {string} key
     * @returns {any}
     */
    EncryptedLocalForageDatabaseEngine.prototype.get = function (key, cacheData) {
        if (cacheData === void 0) { cacheData = null; }
        return this.dataFetcher(key, function (value) { return encryption.decrypt(value) || value; }, cacheData);
    };
    return EncryptedLocalForageDatabaseEngine;
}(LocalForageDatabaseEngine));

module.exports = EncryptedLocalForageDatabaseEngine;
